## Example Code and Results for **sample_model_1.py**

We train the **sample_model_1** with 91 trainin images under dataset\traindir folder and test it with the images under folder 'test5'. 

While training the model validate the training procedure with the images under the folder 'test14'. We train the model for 10 epochs for scale factor of 2.

The output folder contains the training results for other scale (3, and 4) as well.

#### Note
The folder paths are given in Windows style in this code. For the Linux derivatives use '/' instead of '\\'.

    >python -m DeepSR.DeepSR --modelfile "sample_model_1.py" --train --test --traindir "dataset\train" --valdir "dataset\test14" --testpath "dataset\test5" --scale 2 --metrics ALL


DeepSR produces the following folder structure and files for training:
    sample_model_1/
    
        output/
        
            2/
            
                training_summary.txt
                
                training_tf_.log
                
                sample_model_1_test5_results_scale_2.xlsx
                
                sample_model_1_test5_results_scale_2.xlsx.txt
                
                weights.01.h5
                
                ...
                
                weights.10.h5
                
                images/
                
                    z_baby_GT_scale_2_Result_model.png
                    
                    ...
                    
                    ...
                    
                    ....png
            
                
        


### Here is the outcomes of of the train and test procedure 


    Using TensorFlow backend.
    
    [START TRAINING]
    _________________________________________________________________
    Layer (type)                 Output Shape              Param #
    =================================================================
    conv2d_4 (Conv2D)            (None, 25, 25, 64)        5248
    _________________________________________________________________
    conv2d_5 (Conv2D)            (None, 25, 25, 32)        2080
    _________________________________________________________________
    conv2d_6 (Conv2D)            (None, 21, 21, 1)         801
    =================================================================
    Total params: 8,129
    Trainable params: 8,129
    Non-trainable params: 0
    _________________________________________________________________
    None
    Batch generator starting...
    Epoch 1/10
      0%|                                                                                                                                                                                                    | 0/14 [00:00<?, ?it/s]C
    :\Users\hakan\AppData\Local\Programs\Python\Python36\lib\site-packages\skimage\io\_io.py:54: UserWarning: `flatten` has been deprecated in favor of `as_gray` and will be removed in v0.16.             | 0/191 [00:00<?, ?it/s]
      warn('`flatten` has been deprecated in favor of `as_gray`'
    2019-08-21 10:40:57.843410: I tensorflow/core/platform/cpu_feature_guard.cc:141] Your CPU supports instructions that this TensorFlow binary was not compiled to use: AVX2
    2019-08-21 10:40:59.057428: I tensorflow/core/common_runtime/gpu/gpu_device.cc:1432] Found device 0 with properties:
    name: GeForce GTX 960M major: 5 minor: 0 memoryClockRate(GHz): 1.176
    pciBusID: 0000:01:00.0
    totalMemory: 4.00GiB freeMemory: 3.35GiB
    2019-08-21 10:40:59.065776: I tensorflow/core/common_runtime/gpu/gpu_device.cc:1511] Adding visible gpu devices: 0
    2019-08-21 10:41:02.754347: I tensorflow/core/common_runtime/gpu/gpu_device.cc:982] Device interconnect StreamExecutor with strength 1 edge matrix:
    2019-08-21 10:41:02.758149: I tensorflow/core/common_runtime/gpu/gpu_device.cc:988]      0
    2019-08-21 10:41:02.760202: I tensorflow/core/common_runtime/gpu/gpu_device.cc:1001] 0:   N
    2019-08-21 10:41:02.765376: I tensorflow/core/common_runtime/gpu/gpu_device.cc:1115] Created TensorFlow device (/job:localhost/replica:0/task:0/device:GPU:0 with 3063 MB memory) -> physical GPU (device: 0, name: GeForce GTX 9
    60M, pci bus id: 0000:01:00.0, compute capability: 5.0)
    100%|···························································································································································································| 14/14 [00:34<00:00,  2.43s/it]
      0%|                                                                                                                                                                                                   | 0/191 [00:00<?, ?it/s]
    - 34s - loss: 3543.9244 - val_loss: 2692.6709                                                                                                                                                            | 0/14 [00:00<?, ?it/s]
    Epoch 2/10
    100%|·························································································································································································| 191/191 [00:22<00:00, 10.40it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  1.60s/it]
      0%|                                                                                                                                                                                                   | 0/191 [00:00<?, ?it/s]
    - 22s - loss: 2631.2994 - val_loss: 2168.5890                                                                                                                                                            | 0/14 [00:00<?, ?it/s]
    Epoch 3/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  8.55it/s]
     93%|·············································································································································································▋             | 13/14 [00:22<00:01,  1.82s/it]
    - 22s - loss: 2378.1220 - val_loss: 2173.5408                                                                                                                                                           | 0/191 [00:00<?, ?it/s]
    Epoch 4/10
    100%|···························································································································································································| 14/14 [00:43<00:00,  7.60s/it]
     98%|·····················································································································································································▏   | 187/191 [00:21<00:00,  4.46it/s]
    - 22s - loss: 2455.8229 - val_loss: 1941.3704························································································································▎                          | 12/14 [00:01<00:00,  8.53it/s]
    Epoch 5/10
    100%|·························································································································································································| 191/191 [00:23<00:00,  3.65it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  3.23s/it]
     98%|······················································································································································································   | 188/191 [00:20<00:00,  8.53it/s]
    - 22s - loss: 2374.3780 - val_loss: 2119.3981························································································································▎                          | 12/14 [00:01<00:00, 10.89it/s]
    Epoch 6/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  4.45it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  3.22s/it]
     99%|·······················································································································································································  | 189/191 [00:20<00:00,  6.11it/s]
    - 22s - loss: 2334.4798 - val_loss: 1935.1812··········································································································▉                                        | 11/14 [00:01<00:00,  8.32it/s]
    Epoch 7/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  3.11it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  1.60s/it]
     99%|························································································································································································ | 190/191 [00:21<00:00,  6.50it/s]
    - 22s - loss: 2425.0857 - val_loss: 2145.0882························································································································▎                          | 12/14 [00:01<00:00,  9.49it/s]
    Epoch 8/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  1.90it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  1.60s/it]
     99%|·······················································································································································································  | 189/191 [00:20<00:00, 10.20it/s]
    - 22s - loss: 2274.7813 - val_loss: 1945.6539··········································································································▉                                        | 11/14 [00:01<00:00,  9.60it/s]
    Epoch 9/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  2.94it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  1.60s/it]
     99%|························································································································································································ | 190/191 [00:20<00:00,  8.96it/s]
    - 22s - loss: 2392.4492 - val_loss: 2121.7698··········································································································▉                                        | 11/14 [00:01<00:00,  9.20it/s]
    Epoch 10/10
    100%|·························································································································································································| 191/191 [00:22<00:00,  8.52it/s]
    100%|···························································································································································································| 14/14 [00:22<00:00,  2.21s/it]
     99%|·······················································································································································································  | 189/191 [00:20<00:00,  5.40it/s]
    - 22s - loss: 2311.6168 - val_loss: 2322.9311························································································································▎                          | 12/14 [00:01<00:00, 10.74it/s]
    Training has taken 235.473 seconds.
    [TRAIN FINISHED]
    
    [START TEST]
    dataset\test5
                                                                                                                                                                                                                                  [
    TEST FINISHED]····················································································································································································| 5/5 [00:22<00:00,  4.93s/it]

All results are saved in [sample_model_1_test5_results_scale_2.xlsx](sample_model_1/output/2/sample_model_1_test5_results_scale_2.xlsx)